# Record Class CLNImageCubeDescription

java.lang.Object
java.lang.Record
com.io7m.calino.api.CLNImageCubeDescription

Record Components:
  `mipMapLevel` - The mipmap level
  `face` - The cube face
  `dataOffsetWithinSection` - The offset within the section
  `dataSizeUncompressed` - The size of the uncompressed data
  `dataSizeCompressed` - The size of the compressed data
  `crc32Uncompressed` - The CRC32 of the uncompressed data

All Implemented Interfaces:
  `CLNImageDescriptionType, Comparable<CLNImageCubeDescription>`

public record CLNImageCubeDescription(int mipMapLevel, CLNCubeFace face, long dataOffsetWithinSection, long dataSizeUncompressed, long dataSizeCompressed, int crc32Uncompressed) extends Record implements CLNImageDescriptionType, Comparable<CLNImageCubeDescription>
A description of a single cube face image.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CLNImageCubeDescription(int mipMapLevel, CLNCubeFace face, long dataOffsetWithinSection, long dataSizeUncompressed, long dataSizeCompressed, int crc32Uncompressed)`
  A description of a single cube face image.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CLNImageCubeDescription other)`
  `int`
  `crc32Uncompressed()`
  Returns the value of the `crc32Uncompressed` record component.
  `long`
  `dataOffsetWithinSection()`
  Returns the value of the `dataOffsetWithinSection` record component.
  `long`
  `dataSizeCompressed()`
  Returns the value of the `dataSizeCompressed` record component.
  `long`
  `dataSizeUncompressed()`
  Returns the value of the `dataSizeUncompressed` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `CLNCubeFace`
  `face()`
  Returns the value of the `face` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `int`
  `mipMapLevel()`
  Returns the value of the `mipMapLevel` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CLNImageCubeDescription

    public CLNImageCubeDescription(int mipMapLevel, CLNCubeFace face, long dataOffsetWithinSection, long dataSizeUncompressed, long dataSizeCompressed, int crc32Uncompressed)
    A description of a single cube face image.
    Parameters:
      `mipMapLevel` - The mipmap level
      `face` - The cube face
      `dataOffsetWithinSection` - The offset within the section
      `dataSizeUncompressed` - The size of the uncompressed data
      `dataSizeCompressed` - The size of the compressed data
      `crc32Uncompressed` - The CRC32 of the uncompressed data

- ## Method Details

  - ### compareTo

    public int compareTo(CLNImageCubeDescription other)
    Specified by:
      `compareTo` in interface `Comparable<CLNImageCubeDescription>`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### mipMapLevel

    public int mipMapLevel()
    Returns the value of the `mipMapLevel` record component.
    Specified by:
      `mipMapLevel` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `mipMapLevel` record component

  - ### face

    public CLNCubeFace face()
    Returns the value of the `face` record component.
    Returns:
      the value of the `face` record component

  - ### dataOffsetWithinSection

    public long dataOffsetWithinSection()
    Returns the value of the `dataOffsetWithinSection` record component.
    Specified by:
      `dataOffsetWithinSection` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `dataOffsetWithinSection` record component

  - ### dataSizeUncompressed

    public long dataSizeUncompressed()
    Returns the value of the `dataSizeUncompressed` record component.
    Specified by:
      `dataSizeUncompressed` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `dataSizeUncompressed` record component

  - ### dataSizeCompressed

    public long dataSizeCompressed()
    Returns the value of the `dataSizeCompressed` record component.
    Specified by:
      `dataSizeCompressed` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `dataSizeCompressed` record component

  - ### crc32Uncompressed

    public int crc32Uncompressed()
    Returns the value of the `crc32Uncompressed` record component.
    Specified by:
      `crc32Uncompressed` in interface `CLNImageDescriptionType`
    Returns:
      the value of the `crc32Uncompressed` record component